Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/main.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/main.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: main.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -72,6 +72,10 @@
 static EVH SquidShutdown;
 static void mainSetCwd(void);
 
+#if TEST_ACCESS
+#include "test_access.c"
+#endif
+
 static void
 usage(void)
 {
@@ -91,7 +95,7 @@
 	"       -z        Create swap directories\n"
 	"       -C        Do not catch fatal signals.\n"
 	"       -D        Disable initial DNS tests.\n"
-	"       -F        Foreground fast store rebuild.\n"
+	"       -F        Don't serve any requests until store is rebuilt.\n"
 	"       -N        No daemon mode.\n"
 	"       -R        Do not set REUSEADDR on port.\n"
 	"       -V        Virtual host httpd-accelerator.\n"
@@ -280,6 +284,9 @@
 #ifdef SQUID_SNMP
     snmpConnectionOpen();
 #endif
+#if USE_WCCP
+    wccpConnectionOpen();
+#endif
     clientdbInit();
     icmpOpen();
     netdbInit();
@@ -303,6 +310,9 @@
 #ifdef SQUID_SNMP
     snmpConnectionShutdown();
 #endif
+#if USE_WCCP
+    wccpConnectionShutdown();
+#endif
     asnFreeMemory();
 }
 
@@ -320,19 +330,32 @@
 #ifdef SQUID_SNMP
     snmpConnectionClose();
 #endif
+#if USE_WCCP
+    wccpConnectionClose();
+#endif
     dnsShutdown();
+#if !USE_DNSSERVERS
+    idnsShutdown();
+#endif
     redirectShutdown();
     authenticateShutdown();
     storeDirCloseSwapLogs();
     errorClean();
+    mimeFreeMemory();
     parseConfigFile(ConfigFile);
     _db_init(Config.Log.log, Config.debugOptions);
     ipcache_restart();		/* clear stuck entries */
     fqdncache_restart();	/* sigh, fqdncache too */
     errorInitialize();		/* reload error pages */
     dnsInit();
+#if !USE_DNSSERVERS
+    idnsInit();
+#endif
     redirectInit();
     authenticateInit();
+#if USE_WCCP
+    wccpInit();
+#endif
     serverConnectionsOpen();
     if (theOutIcpConnection >= 0) {
 	if (!Config2.Accel.on || Config.onoff.accel_with_proxy)
@@ -341,6 +364,7 @@
 	    debug(1, 1) ("ICP port disabled in httpd_accelerator mode\n");
     }
     storeDirOpenSwapLogs();
+    mimeInit(Config.mimeTablePathname);
     writePidFile();		/* write PID file */
     debug(1, 1) ("Ready to serve requests.\n");
     reconfiguring = 0;
@@ -405,6 +429,10 @@
 static void
 mainInitialize(void)
 {
+    /* chroot if configured to run inside chroot */
+    if (Config.chroot_dir && chroot(Config.chroot_dir)) {
+	fatal("failed to chroot");
+    }
     if (opt_catch_signals) {
 	squid_signal(SIGSEGV, death, SA_NODEFER | SA_RESETHAND);
 	squid_signal(SIGBUS, death, SA_NODEFER | SA_RESETHAND);
@@ -413,9 +441,9 @@
     squid_signal(SIGCHLD, sig_child, SA_NODEFER | SA_RESTART);
 
     setEffectiveUser();
-    assert(Config.Port.http);
+    assert(Config.Sockaddr.http);
     if (httpPortNumOverride != 1)
-	Config.Port.http->i = (u_short) httpPortNumOverride;
+	Config.Sockaddr.http->s.sin_port = htons(httpPortNumOverride);
     if (icpPortNumOverride != 1)
 	Config.Port.icp = (u_short) icpPortNumOverride;
 
@@ -435,6 +463,9 @@
     ipcache_init();
     fqdncache_init();
     dnsInit();
+#if !USE_DNSSERVERS
+    idnsInit();
+#endif
     redirectInit();
     authenticateInit();
     useragentOpenLog();
@@ -448,12 +479,14 @@
 #ifdef SQUID_SNMP
     snmpInit();
 #endif
-
 #if MALLOC_DBG
     malloc_debug(0, malloc_debug_level);
 #endif
 
     if (!configured_once) {
+#if USE_ASYNC_IO
+	aioInit();
+#endif
 	unlinkdInit();
 	urlInitialize();
 	cachemgrInit();
@@ -464,13 +497,15 @@
 	do_mallinfo = 1;
 	mimeInit(Config.mimeTablePathname);
 	pconnInit();
-	eventInit();
 	refreshInit();
 #if DELAY_POOLS
 	delayPoolsInit();
 #endif
 	fwdInit();
     }
+#if USE_WCCP
+    wccpInit();
+#endif
     serverConnectionsOpen();
     if (theOutIcpConnection >= 0) {
 	if (!Config2.Accel.on || Config.onoff.accel_with_proxy)
@@ -478,6 +513,8 @@
 	else
 	    debug(1, 1) ("ICP port disabled in httpd_accelerator mode\n");
     }
+    if (Config.chroot_dir)
+	no_suid();
     if (!configured_once)
 	writePidFile();		/* write PID file */
 
@@ -495,11 +532,10 @@
     squid_signal(SIGALRM, time_tick, SA_RESTART);
     alarm(1);
 #endif
+    memCheckInit();
     debug(1, 1) ("Ready to serve requests.\n");
-
     if (!configured_once) {
 	eventAdd("storeMaintain", storeMaintainSwapSpace, NULL, 1.0, 1);
-	eventAdd("storeDirClean", storeDirClean, NULL, 15.0, 1);
 	if (Config.onoff.announce)
 	    eventAdd("start_announce", start_announce, NULL, 3600.0, 1);
 	eventAdd("ipcache_purgelru", ipcache_purgelru, NULL, 10.0, 1);
@@ -514,6 +550,7 @@
     int errcount = 0;
     int n;			/* # of GC'd objects */
     time_t loop_delay;
+    mode_t oldmask;
 
     debug_log = stderr;
     if (FD_SETSIZE < Squid_MaxFD)
@@ -535,6 +572,16 @@
 #endif
 #endif /* HAVE_MALLOPT */
 
+    /*
+     * The plan here is to set the umask to 007 (deny others for
+     * read,write,execute), but only if the umask is not already
+     * set.  Unfortunately, there is no way to get the current
+     * umask value without setting it.
+     */
+    oldmask = umask(S_IRWXO);
+    if (oldmask)
+	umask(oldmask);
+
     memset(&local_addr, '\0', sizeof(struct in_addr));
     safe_inet_addr(localhost, &local_addr);
     memset(&any_addr, '\0', sizeof(struct in_addr));
@@ -561,18 +608,35 @@
 	leakInit();
 #endif
 	memInit();		/* memInit is required for config parsing */
+	eventInit();		/* eventInit() is required for config parsing */
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
 	    return parse_err;
     }
 
+#if TEST_ACCESS
+    comm_init();
+    comm_select_init();
+    mainInitialize();
+    test_access();
+    return 0;
+#endif
+
     /* send signal to running copy and exit */
     if (opt_send_signal != -1) {
+	/* chroot if configured to run inside chroot */
+	if (Config.chroot_dir && chroot(Config.chroot_dir)) {
+	    fatal("failed to chroot");
+	}
 	sendSignal();
 	/* NOTREACHED */
     }
     if (opt_create_swap_dirs) {
+	/* chroot if configured to run inside chroot */
+	if (Config.chroot_dir && chroot(Config.chroot_dir)) {
+	    fatal("failed to chroot");
+	}
 	setEffectiveUser();
 	debug(0, 0) ("Creating Swap Directories\n");
 	storeCreateSwapDirectories();
@@ -616,6 +680,9 @@
 	    shutting_down = 1;
 	    serverConnectionsClose();
 	    dnsShutdown();
+#if !USE_DNSSERVERS
+	    idnsShutdown();
+#endif
 	    redirectShutdown();
 	    authenticateShutdown();
 	    eventAdd("SquidShutdown", SquidShutdown, NULL, (double) (wait + 1), 1);
@@ -705,9 +772,6 @@
 #endif
     for (i = 0; i < Squid_MaxFD; i++)
 	close(i);
-#if NOT_NEEDED
-    umask(0);
-#endif
     for (;;) {
 	if ((pid = fork()) == 0) {
 	    /* child */
@@ -770,6 +834,9 @@
 #ifdef SQUID_SNMP
     snmpConnectionClose();
 #endif
+#if USE_WCCP
+    wccpConnectionClose();
+#endif
     releaseServerSockets();
     commCloseAllSockets();
     unlinkdClose();
@@ -821,6 +888,7 @@
 #endif
     debug(1, 1) ("Squid Cache (Version %s): Exiting normally.\n",
 	version_string);
-    fclose(debug_log);
+    if (debug_log)
+	fclose(debug_log);
     exit(0);
 }
Index: squid/src/mem.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mem.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/mem.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/mem.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mem.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: mem.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 13    High Level Memory Pool Management
  * AUTHOR: Harvest Derived
@@ -65,17 +65,6 @@
 
 /* local routines */
 
-/*
- * we have a limit on _total_ amount of idle memory so we ignore
- * max_pages for now
- */
-static void
-memDataInit(mem_type type, const char *name, size_t size, int max_pages_notused)
-{
-    assert(name && size);
-    MemPools[type] = memPoolCreate(name, size);
-}
-
 static void
 memStringStats(StoreEntry * sentry)
 {
@@ -119,6 +108,17 @@
  * public routines
  */
 
+/*
+ * we have a limit on _total_ amount of idle memory so we ignore
+ * max_pages for now
+ */
+void
+memDataInit(mem_type type, const char *name, size_t size, int max_pages_notused)
+{
+    assert(name && size);
+    MemPools[type] = memPoolCreate(name, size);
+}
+
 
 /* find appropriate pool and use it (pools always init buffer with 0s) */
 void *
@@ -177,7 +177,6 @@
 memInit(void)
 {
     int i;
-    mem_type t;
     memInitModule();
     /* set all pointers to null */
     memset(MemPools, '\0', sizeof(MemPools));
@@ -291,7 +290,23 @@
 	sizeof(helper_request), 0);
     memDataInit(MEM_HELPER_SERVER, "helper_server",
 	sizeof(helper_server), 0);
-    /* test that all entries are initialized */
+    memDataInit(MEM_STORE_IO, "storeIOState", sizeof(storeIOState), 0);
+    /* init string pools */
+    for (i = 0; i < mem_str_pool_count; i++) {
+	StrPools[i].pool = memPoolCreate(StrPoolsAttrs[i].name, StrPoolsAttrs[i].obj_size);
+    }
+    cachemgrRegister("mem",
+	"Memory Utilization",
+	memStats, 0, 1);
+}
+
+/*
+ * Test that all entries are initialized
+ */
+void
+memCheckInit(void)
+{
+    mem_type t;
     for (t = MEM_NONE, t++; t < MEM_MAX; t++) {
 	if (MEM_DONTFREE == t)
 	    continue;
@@ -301,17 +316,10 @@
 	 */
 	assert(MemPools[t]);
     }
-    /* init string pools */
-    for (i = 0; i < mem_str_pool_count; i++) {
-	StrPools[i].pool = memPoolCreate(StrPoolsAttrs[i].name, StrPoolsAttrs[i].obj_size);
-    }
-    cachemgrRegister("mem",
-	"Memory Utilization",
-	memStats, 0, 1);
 }
 
 void
-memClean()
+memClean(void)
 {
     memCleanModule();
 }
Index: squid/src/mime.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mime.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/mime.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/mime.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mime.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: mime.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 25    MIME Parsing
  * AUTHOR: Harvest Derived
@@ -401,7 +401,7 @@
     if (storeGetPublic(url, METHOD_GET))
 	return;
     snprintf(path, MAXPATHLEN, "%s/%s", Config.icons.directory, icon);
-    fd = file_open(path, O_RDONLY, NULL, NULL, NULL);
+    fd = file_open(path, O_RDONLY);
     if (fd < 0) {
 	debug(25, 0) ("mimeLoadIconFile: %s: %s\n", path, xstrerror());
 	return;
@@ -418,6 +418,7 @@
 	METHOD_GET);
     assert(e != NULL);
     storeSetPublicKey(e);
+    storeBuffer(e);
     e->mem_obj->request = requestLink(urlParse(METHOD_GET, url));
     httpReplyReset(reply = e->mem_obj->reply);
     httpReplySetHeaders(reply, 1.0, HTTP_OK, NULL,
@@ -426,14 +427,16 @@
     httpHdrCcSetMaxAge(reply->cache_control, 86400);
     httpHeaderPutCc(&reply->header, reply->cache_control);
     httpReplySwapOut(reply, e);
+    reply->hdr_sz = e->mem_obj->inmem_hi;	/* yuk */
     /* read the file into the buffer and append it to store */
     buf = memAllocate(MEM_4K_BUF);
     while ((n = read(fd, buf, 4096)) > 0)
 	storeAppend(e, buf, n);
     file_close(fd);
+    EBIT_SET(e->flags, ENTRY_SPECIAL);
+    storeBufferFlush(e);
     storeComplete(e);
     storeTimestampsSet(e);
-    EBIT_SET(e->flags, ENTRY_SPECIAL);
     debug(25, 3) ("Loaded icon %s\n", url);
     storeUnlockObject(e);
     memFree(buf, MEM_4K_BUF);
Index: squid/src/mime.conf
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/mime.conf,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/mime.conf	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/mime.conf	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -14,8 +14,8 @@
 #
 # regexp	content-type			icon		encoding	mode
 #-----------------------------------------------------------------------------------
-\.gif$		image/gif			anthony-image.gif		-		image
-\.mime$		www/mime			anthony-text.gif	-	ascii	+download
+\.gif$			image/gif		anthony-image.gif	-	image
+\.mime$			www/mime		anthony-text.gif	-	ascii	+download
 ^internal-dirup$	-			anthony-dirup.gif	-	ascii
 ^internal-dir$		-			anthony-dir.gif		-	ascii
 ^internal-link$		-			anthony-link.gif	-	ascii
@@ -30,105 +30,106 @@
 ^internal-unknown$	-			anthony-unknown.gif	-	ascii
 ^internal-view$		-			anthony-text.gif	-	ascii
 ^internal-download$	-			anthony-box.gif		-	ascii
-\.bin$		application/macbinary		anthony-unknown.gif		-		image
-\.oda$		application/oda			anthony-unknown.gif		-		image
-\.exe$		application/octet-stream	anthony-unknown.gif		-		image
-\.pdf$		application/pdf			anthony-unknown.gif		-		image
+\.bin$		application/macbinary		anthony-unknown.gif	-	image
+\.oda$		application/oda			anthony-unknown.gif	-	image
+\.exe$		application/octet-stream	anthony-unknown.gif	-	image
+\.pdf$		application/pdf			anthony-unknown.gif	-	image
 \.ai$		application/postscript		anthony-ps.gif		-	ascii	+download
 \.eps$		application/postscript		anthony-ps.gif		-	ascii	+download
 \.ps$		application/postscript		anthony-ps.gif		-	ascii	+download +view
-\.rtf$		application/x-rtf		anthony-unknown.gif		-		image
-\.Z$		-				anthony-compressed.gif		compress	image
-\.gz$		-				anthony-unknown.gif		gzip		image
-\.tgz$		application/x-tar		anthony-tar.gif		gzip		image
-\.csh$		application/x-csh		anthony-script.gif		-		ascii
-\.dvi$		application/x-dvi		anthony-dvi.gif		-		image
-\.hdf$		application/x-hdf		anthony-unknown.gif		-		image
-\.latex$	application/x-latex		anthony-tex.gif		-		ascii
-\.lsm$		text/plain			anthony-text.gif		-		ascii
-\.nc$		application/x-netcdf		anthony-unknown.gif		-		image
+\.rtf$		application/x-rtf		anthony-unknown.gif	-	image
+\.Z$		-				anthony-compressed.gif	compress image
+\.gz$		-				anthony-unknown.gif	gzip	image
+\.tgz$		application/x-tar		anthony-tar.gif		gzip	image
+\.csh$		application/x-csh		anthony-script.gif	-	ascii
+\.dvi$		application/x-dvi		anthony-dvi.gif		-	image
+\.hdf$		application/x-hdf		anthony-unknown.gif	-	image
+\.latex$	application/x-latex		anthony-tex.gif		-	ascii
+\.lsm$		text/plain			anthony-text.gif	-	ascii
+\.nc$		application/x-netcdf		anthony-unknown.gif	-	image
 \.cdf$		application/x-netcdf		anthony-unknown.gif	-	ascii	+download
-\.sh$		application/x-sh		anthony-script.gif		-		ascii
+\.sh$		application/x-sh		anthony-script.gif	-	ascii
 \.tcl$		application/x-tcl		anthony-script.gif	-	ascii	+view
-\.tex$		application/x-tex		anthony-tex.gif		-		ascii
-\.texi$		application/x-texinfo		anthony-tex.gif		-		ascii
-\.texinfo$	application/x-texinfo		anthony-tex.gif		-		ascii
-\.t$		application/x-troff		anthony-text.gif		-		ascii
-\.roff$		application/x-troff		anthony-text.gif		-		ascii
-\.tr$		application/x-troff		anthony-text.gif		-		ascii
-\.man$		application/x-troff-man		anthony-text.gif		-		ascii
-\.me$		application/x-troff-me		anthony-text.gif		-		ascii
-\.ms$		application/x-troff-ms		anthony-text.gif		-		ascii
+\.tex$		application/x-tex		anthony-tex.gif		-	ascii
+\.texi$		application/x-texinfo		anthony-tex.gif		-	ascii
+\.texinfo$	application/x-texinfo		anthony-tex.gif		-	ascii
+\.t$		application/x-troff		anthony-text.gif	-	ascii
+\.roff$		application/x-troff		anthony-text.gif	-	ascii
+\.tr$		application/x-troff		anthony-text.gif	-	ascii
+\.man$		application/x-troff-man		anthony-text.gif	-	ascii
+\.me$		application/x-troff-me		anthony-text.gif	-	ascii
+\.ms$		application/x-troff-ms		anthony-text.gif	-	ascii
 \.src$		application/x-wais-source	anthony-text.gif	-	ascii	+download
-\.zip$		application/x-zip-compressed	anthony-compressed.gif		-		image
-\.bcpio$	application/x-bcpio		anthony-unknown.gif		-		image
-\.cpio$		application/x-cpio		anthony-unknown.gif		-		image
-\.gtar$		application/x-gtar		anthony-tar.gif		-		image
-\.rpm$		application/x-rpm		anthony-unknown.gif		-		image
-\.shar$		application/x-shar		anthony-script.gif	-	ascii	+download
-\.sv4cpio$	application/x-sv4cpio		anthony-unknown.gif		-		image
-\.sv4crc$	application/x-sv4crc		anthony-unknown.gif		-		image
-\.tar$		application/x-tar		anthony-tar.gif		-		image
-\.ustar$	application/x-ustar		anthony-tar.gif		-		image
-\.au$		audio/basic			anthony-sound.gif		-		image
-\.snd$		audio/basic			anthony-sound.gif		-		image
-\.mp2$		audio/basic			anthony-sound.gif		-		image
-\.mp3$		audio/basic			anthony-sound.gif		-		image
-\.aif$		audio/x-aiff			anthony-sound.gif		-		image
-\.aiff$		audio/x-aiff			anthony-sound.gif		-		image
-\.aifc$		audio/x-aiff			anthony-sound.gif		-		image
-\.wav$		audio/x-wav			anthony-sound.gif		-		image
-\.ief$		image/ief			anthony-image.gif		-		image
-\.jpeg$		image/jpeg			anthony-image.gif		-		image
-\.jpg$		image/jpeg			anthony-image.gif		-		image
-\.jpe$		image/jpeg			anthony-image.gif		-		image
-\.tiff$		image/tiff			anthony-image.gif		-		image
-\.tif$		image/tiff			anthony-image.gif		-		image
-\.ras$		image/cmu-raster		anthony-image.gif		-		image
-\.pnm$		image/x-portable-anymap		anthony-image.gif		-		image
-\.pbm$		image/x-portable-bitmap		anthony-image.gif		-		image
-\.pgm$		image/x-portable-graymap	anthony-image.gif		-		image
-\.ppm$		image/x-portable-pixmap		anthony-image.gif		-		image
-\.rgb$		image/x-rgb			anthony-image.gif		-		image
-\.xbm$		image/x-xbitmap			anthony-xbm.gif		-		image
-\.xpm$		image/x-xpixmap			anthony-xpm.gif		-		image
-\.xwd$		image/x-xwindowdump		anthony-image.gif		-		image
-\.html$		text/html			anthony-text.gif		-		ascii
-\.htm$		text/html			anthony-text.gif		-		ascii
-\.c$		text/plain			anthony-c.gif		-		ascii
-\.h$		text/plain			anthony-c.gif		-		ascii
-\.cc$		text/plain			anthony-c.gif		-		ascii
-\.hh$		text/plain			anthony-c.gif		-		ascii
-\.m$		text/plain			anthony-text.gif		-		ascii
-\.f90$		text/plain			anthony-text.gif		-		ascii
-\.txt$		text/plain			anthony-text.gif		-		ascii
+\.zip$		application/x-zip-compressed	anthony-compressed.gif	-	image
+\.bcpio$	application/x-bcpio		anthony-unknown.gif	-	image
+\.cpio$		application/x-cpio		anthony-unknown.gif	-	image
+\.gtar$		application/x-gtar		anthony-tar.gif		-	image
+\.rpm$		application/x-rpm		anthony-unknown.gif	-	image
+\.shar$		application/x-shar		anthony-script.gif	-	image	+download +view
+\.sv4cpio$	application/x-sv4cpio		anthony-unknown.gif	-	image
+\.sv4crc$	application/x-sv4crc		anthony-unknown.gif	-	image
+\.tar$		application/x-tar		anthony-tar.gif		-	image
+\.ustar$	application/x-ustar		anthony-tar.gif		-	image
+\.au$		audio/basic			anthony-sound.gif	-	image
+\.snd$		audio/basic			anthony-sound.gif	-	image
+\.mp2$		audio/basic			anthony-sound.gif	-	image
+\.mp3$		audio/basic			anthony-sound.gif	-	image
+\.aif$		audio/x-aiff			anthony-sound.gif	-	image
+\.aiff$		audio/x-aiff			anthony-sound.gif	-	image
+\.aifc$		audio/x-aiff			anthony-sound.gif	-	image
+\.wav$		audio/x-wav			anthony-sound.gif	-	image
+\.ief$		image/ief			anthony-image.gif	-	image
+\.jpeg$		image/jpeg			anthony-image.gif	-	image
+\.jpg$		image/jpeg			anthony-image.gif	-	image
+\.jpe$		image/jpeg			anthony-image.gif	-	image
+\.tiff$		image/tiff			anthony-image.gif	-	image
+\.tif$		image/tiff			anthony-image.gif	-	image
+\.ras$		image/cmu-raster		anthony-image.gif	-	image
+\.pnm$		image/x-portable-anymap		anthony-image.gif	-	image
+\.pbm$		image/x-portable-bitmap		anthony-image.gif	-	image
+\.pgm$		image/x-portable-graymap	anthony-image.gif	-	image
+\.ppm$		image/x-portable-pixmap		anthony-image.gif	-	image
+\.rgb$		image/x-rgb			anthony-image.gif	-	image
+\.xbm$		image/x-xbitmap			anthony-xbm.gif		-	image
+\.xpm$		image/x-xpixmap			anthony-xpm.gif		-	image
+\.xwd$		image/x-xwindowdump		anthony-image.gif	-	image
+\.html$		text/html			anthony-text.gif	-	ascii
+\.htm$		text/html			anthony-text.gif	-	ascii
+\.c$		text/plain			anthony-c.gif		-	ascii
+\.h$		text/plain			anthony-c.gif		-	ascii
+\.cc$		text/plain			anthony-c.gif		-	ascii
+\.hh$		text/plain			anthony-c.gif		-	ascii
+\.m$		text/plain			anthony-text.gif	-	ascii
+\.f90$		text/plain			anthony-text.gif	-	ascii
+\.txt$		text/plain			anthony-text.gif	-	ascii
 \.rtx$		text/richtext			anthony-text.gif	-	ascii	+download
 \.tsv$		text/tab-separated-values	anthony-text.gif	-	ascii	+download
 \.etx$		text/x-setext			anthony-text.gif	-	ascii	+download
-\.mpeg$		video/mpeg			anthony-movie.gif		-		image
-\.mpg$		video/mpeg			anthony-movie.gif		-		image
-\.mpe$		video/mpeg			anthony-movie.gif		-		image
-\.qt$		video/quicktime			anthony-movie.gif		-		image
-\.mov$		video/quicktime			anthony-movie.gif		-		image
-\.avi$		video/x-msvideo			anthony-movie.gif		-		image
-\.movie$	video/x-sgi-movie		anthony-movie.gif		-		image
-\.hqx$		application/mac-binhex40	anthony-binhex.gif		-		image
-\.mwrt$		application/macwriteii		anthony-unknown.gif		-		image
-\.msw$		application/msword		anthony-unknown.gif		-		image
+\.mpeg$		video/mpeg			anthony-movie.gif	-	image
+\.mpg$		video/mpeg			anthony-movie.gif	-	image
+\.mpe$		video/mpeg			anthony-movie.gif	-	image
+\.qt$		video/quicktime			anthony-movie.gif	-	image
+\.mov$		video/quicktime			anthony-movie.gif	-	image
+\.avi$		video/x-msvideo			anthony-movie.gif	-	image
+\.movie$	video/x-sgi-movie		anthony-movie.gif	-	image
+\.hqx$		application/mac-binhex40	anthony-binhex.gif	-	image
+\.mwrt$		application/macwriteii		anthony-unknown.gif	-	image
+\.msw$		application/msword		anthony-unknown.gif	-	image
 \.doc$		application/msword		anthony-unknown.gif	-	image	+view
 \.xls$		application/msexcel		anthony-unknown.gif	-	image
 \.wk[s1234]$	application/vnd.lotus-1-2-3	anthony-unknown.gif	-	image
-\.mif$		application/x-mif		anthony-unknown.gif		-		image
-\.sit$		application/stuffit		anthony-unknown.gif		-		image
-\.pict$		application/pict		anthony-image.gif		-		image
-\.pic$		application/pict		anthony-image.gif		-		image
-\.arj$		application/x-arj-compressed	anthony-compressed.gif		-		image
-\.lzh$		application/x-lha-compressed	anthony-compressed.gif		-		image
-\.lha$		application/x-lha-compressed	anthony-compressed.gif		-		image
-\.zlib$		application/x-deflate		anthony-compressed.gif		deflate		image
+\.mif$		application/x-mif		anthony-unknown.gif	-	image
+\.sit$		application/stuffit		anthony-unknown.gif	-	image
+\.pict$		application/pict		anthony-image.gif	-	image
+\.pic$		application/pict		anthony-image.gif	-	image
+\.arj$		application/x-arj-compressed	anthony-compressed.gif	-	image
+\.lzh$		application/x-lha-compressed	anthony-compressed.gif	-	image
+\.lha$		application/x-lha-compressed	anthony-compressed.gif	-	image
+\.zlib$		application/x-deflate		anthony-compressed.gif	deflate	image
 README		text/plain			anthony-text.gif	-	ascii	+download
-^core$		application/octet-stream	anthony-bomb.gif		-		image
-\.core$		application/octet-stream	anthony-bomb.gif		-		image
-\.png$		image/png			anthony-image.gif		-		image
+^core$		application/octet-stream	anthony-bomb.gif	-	image
+\.core$		application/octet-stream	anthony-bomb.gif	-	image
+\.png$		image/png			anthony-image.gif	-	image
+\.cab$		application/octet-stream	anthony-compressed.gif	-	image	+view
 # the default
 .		text/plain			anthony-unknown.gif	-	image	+view +download
Index: squid/src/neighbors.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/neighbors.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/neighbors.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/neighbors.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: neighbors.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: neighbors.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 15    Neighbor Routines
  * AUTHOR: Harvest Derived
@@ -102,7 +102,7 @@
 {
     const struct _domain_type *d = NULL;
     for (d = p->typelist; d; d = d->next) {
-	if (matchDomainName(d->domain, request->host))
+	if (0 == matchDomainName(request->host, d->domain))
 	    if (d->type != PEER_NONE)
 		return d->type;
     }
@@ -136,7 +136,7 @@
 	return do_ping;
     do_ping = 0;
     for (d = p->peer_domain; d; d = d->next) {
-	if (matchDomainName(d->domain, request->host)) {
+	if (0 == matchDomainName(request->host, d->domain)) {
 	    do_ping = d->do_ping;
 	    break;
 	}
@@ -148,6 +148,7 @@
 	return do_ping;
     checklist.src_addr = request->client_addr;
     checklist.my_addr = request->my_addr;
+    checklist.my_port = request->my_port;
     checklist.request = request;
     return aclCheckFast(p->access, &checklist);
 }
@@ -506,10 +507,15 @@
      */
     if (Config.Timeout.icp_query)
 	*timeout = Config.Timeout.icp_query;
-    else if (*exprep > 0)
-	(*timeout) = 2 * (*timeout) / (*exprep);
-    else
-	*timeout = 2000;	/* 2 seconds */
+    else {
+	if (*exprep > 0)
+	    (*timeout) = 2 * (*timeout) / (*exprep);
+	else
+	    *timeout = 2000;	/* 2 seconds */
+	if (Config.Timeout.icp_query_max)
+	    if (*timeout > Config.Timeout.icp_query_max)
+		*timeout = Config.Timeout.icp_query_max;
+    }
     return peers_pinged;
 }
 
@@ -1301,7 +1307,7 @@
 	neighborCountIgnored(p);
 	return;
     }
-    debug(15, 1) ("neighborsHtcpReply: e = %p\n", e);
+    debug(15, 3) ("neighborsHtcpReply: e = %p\n", e);
     mem->ping_reply_callback(p, ntype, PROTO_HTCP, htcp, mem->ircb_data);
 }
 #endif
Index: squid/src/net_db.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/net_db.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/net_db.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/net_db.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: net_db.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: net_db.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 38    Network Measurement Database
  * AUTHOR: Duane Wessels
@@ -528,7 +528,7 @@
 	    debug(38, 5) ("netdbExchangeHandleReply: hdr_sz = %d\n", hdr_sz);
 	    rep = ex->e->mem_obj->reply;
 	    if (0 == rep->sline.status)
-		httpReplyParse(rep, buf);
+		httpReplyParse(rep, buf, hdr_sz);
 	    debug(38, 3) ("netdbExchangeHandleReply: reply status %d\n",
 		rep->sline.status);
 	    if (HTTP_OK != rep->sline.status) {
@@ -973,7 +973,9 @@
     storeClientCopy(ex->e, ex->seen, ex->used, ex->buf_sz,
 	ex->buf, netdbExchangeHandleReply, ex);
     ex->r->flags.loopdetect = 1;	/* cheat! -- force direct */
-    fwdStart(-1, ex->e, ex->r, no_addr, no_addr);
+    if (p->login)
+	xstrncpy(ex->r->login, p->login, MAX_LOGIN_SZ);
+    fwdStart(-1, ex->e, ex->r);
 #endif
 }
 
Index: squid/src/peer_digest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/peer_digest.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/peer_digest.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/peer_digest.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: peer_digest.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: peer_digest.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 72    Peer Digest Routines
  * AUTHOR: Alex Rousskov
@@ -275,7 +275,12 @@
     pd->flags.requested = 1;
 
     /* compute future request components */
-    url = internalRemoteUri(p->host, p->http_port, "/squid-internal-periodic/", StoreDigestFileName);
+    if (p->digest_url)
+	url = xstrdup(p->digest_url);
+    else
+	url = internalRemoteUri(p->host, p->http_port,
+	    "/squid-internal-periodic/", StoreDigestFileName);
+
     key = storeKeyPublic(url, METHOD_GET);
     debug(72, 2) ("peerDigestRequest: %s key: %s\n", url, storeKeyText(key));
     req = urlParse(METHOD_GET, url);
@@ -285,7 +290,8 @@
     assert(!req->header.len);
     httpHeaderPutStr(&req->header, HDR_ACCEPT, StoreDigestMimeStr);
     httpHeaderPutStr(&req->header, HDR_ACCEPT, "text/html");
-
+    if (p->login)
+	xstrncpy(req->login, p->login, MAX_LOGIN_SZ);
     /* create fetch state structure */
     fetch = memAllocate(MEM_DIGEST_FETCH_STATE);
     cbdataAdd(fetch, memFree, MEM_DIGEST_FETCH_STATE);
@@ -317,7 +323,7 @@
 
     /* push towards peer cache */
     debug(72, 3) ("peerDigestRequest: forwarding to fwdStart...\n");
-    fwdStart(-1, e, req, no_addr, no_addr);
+    fwdStart(-1, e, req);
     cbdataLock(fetch);
     cbdataLock(fetch->pd);
     storeClientCopy(e, 0, 0, 4096, memAllocate(MEM_4K_BUF),
@@ -330,17 +336,18 @@
 {
     DigestFetchState *fetch = data;
     PeerDigest *pd = fetch->pd;
+    size_t hdr_size;
     assert(pd && buf);
     assert(!fetch->offset);
 
     if (peerDigestFetchedEnough(fetch, buf, size, "peerDigestFetchReply"))
 	return;
 
-    if (headersEnd(buf, size)) {
+    if ((hdr_size = headersEnd(buf, size))) {
 	http_status status;
 	HttpReply *reply = fetch->entry->mem_obj->reply;
 	assert(reply);
-	httpReplyParse(reply, buf);
+	httpReplyParse(reply, buf, hdr_size);
 	status = reply->sline.status;
 	debug(72, 3) ("peerDigestFetchReply: %s status: %d, expires: %d (%+d)\n",
 	    strBuf(pd->host), status,
@@ -410,7 +417,7 @@
     if ((hdr_size = headersEnd(buf, size))) {
 	assert(fetch->entry->mem_obj->reply);
 	if (!fetch->entry->mem_obj->reply->sline.status)
-	    httpReplyParse(fetch->entry->mem_obj->reply, buf);
+	    httpReplyParse(fetch->entry->mem_obj->reply, buf, hdr_size);
 	if (fetch->entry->mem_obj->reply->sline.status != HTTP_OK) {
 	    debug(72, 1) ("peerDigestSwapInHeaders: %s status %d got cached!\n",
 		strBuf(fetch->pd->host), fetch->entry->mem_obj->reply->sline.status);
Index: squid/src/peer_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/peer_select.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/peer_select.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/peer_select.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: peer_select.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: peer_select.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 44    Peer Selection Algorithm
  * AUTHOR: Duane Wessels
@@ -52,7 +52,8 @@
     "SOURCE_FASTEST",
     "ROUNDROBIN_PARENT",
 #if USE_CACHE_DIGESTS
-    "CACHE_DIGEST_HIT",
+    "CD_PARENT_HIT",
+    "CD_SIBLING_HIT",
 #endif
 #if USE_CARP
     "CARP",
@@ -236,9 +237,6 @@
 	    ps->acl_checklist = aclChecklistCreate(
 		Config.accessList.AlwaysDirect,
 		request,
-		request->client_addr,
-		request->my_addr,
-		NULL,		/* user agent */
 		NULL);		/* ident */
 	    aclNBCheck(ps->acl_checklist,
 		peerCheckAlwaysDirectDone,
@@ -250,9 +248,6 @@
 	    ps->acl_checklist = aclChecklistCreate(
 		Config.accessList.NeverDirect,
 		request,
-		request->client_addr,
-		request->my_addr,
-		NULL,		/* user agent */
 		NULL);		/* ident */
 	    aclNBCheck(ps->acl_checklist,
 		peerCheckNeverDirectDone,
@@ -310,7 +305,10 @@
     }
 #if USE_CACHE_DIGESTS
     if ((p = neighborsDigestSelect(request, entry))) {
-	code = CACHE_DIGEST_HIT;
+	if (neighborType(p, request) == PEER_PARENT)
+	    code = CD_PARENT_HIT;
+	else
+	    code = CD_SIBLING_HIT;
     } else
 #endif
 #if USE_CARP
@@ -534,7 +532,6 @@
 peerHandleHtcpReply(peer * p, peer_t type, htcpReplyData * htcp, void *data)
 {
     ps_state *psstate = data;
-    request_t *request = psstate->request;
     debug(44, 3) ("peerHandleIcpReply: %s %s\n",
 	htcp->hit ? "HIT" : "MISS",
 	storeUrl(psstate->entry));
